



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用 Python 创建你自己的 Shell（下）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用 Python 创建你自己的 Shell（下）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 00:03:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<table>
<tbody>
<tr>
<td>导读</td>
<td><strong>在上篇中，我们已经创建了一个 shell 主循环、切分了命令输入，以及通过 fork 和 exec 执行命令。在这部分，我们将会解决剩下的问题。首先，cd test_dir2 命令无法修改我们的当前目录。其次，我们仍无法优雅地从 shell 中退出。</strong></td>
</tr>
</tbody>
</table>
<p><img referrerpolicy="no-referrer"src="http://www.linuxprobe.com/wp-content/uploads/2016/01/Python_move_github.jpg" /></p>
<div><strong>步骤 4：内置命令</strong></div>
<p>&ldquo;cd test_dir2 无法修改我们的当前目录&rdquo; 这句话是对的，但在某种意义上也是错的。在执行完该命令之后，我们仍然处在同一目录，从这个意义上讲，它是对的。然而，目录实际上已经被修改，只不过它是在子进程中被修改。</p>
<p>还记得我们分叉（fork）了一个子进程，然后执行命令，执行命令的过程没有发生在父进程上。结果是我们只是改变了子进程的当前目录，而不是父进程的目录。</p>
<p>然后子进程退出，而父进程在原封不动的目录下继续运行。</p>
<p>因此，这类与 shell 自己相关的命令必须是内置命令。它必须在 shell 进程中执行而不是在分叉中（forking）。</p>
<div><strong>cd</strong></div>
<p>让我们从 cd 命令开始。</p>
<p>我们首先创建一个 builtins 目录。每一个内置命令都会被放进这个目录中。</p>
<pre class="prettyprint linenums">yosh_project<br />
|-- yosh<br />
   |-- builtins<br />
   |   |-- __init__.py<br />
   |   |-- cd.py<br />
   |-- __init__.py<br />
   |-- shell.py
</pre>
<p>在 cd.py 中，我们通过使用系统调用 os.chdir 实现自己的 cd 命令。</p>
<pre class="prettyprint linenums">import os<br />
from yosh.constants import *

def cd(args):<br />
    os.chdir(args[0])

    return SHELL_STATUS_RUN
</pre>
<p>注意，我们会从内置函数返回 shell 的运行状态。所以，为了能够在项目中继续使用常量，我们将它们移至 yosh/constants.py。</p>
<pre class="prettyprint linenums">yosh_project<br />
|-- yosh<br />
   |-- builtins<br />
   |   |-- __init__.py<br />
   |   |-- cd.py<br />
   |-- __init__.py<br />
   |-- constants.py<br />
   |-- shell.py
</pre>
<p>在 constants.py 中，我们将状态常量都放在这里。</p>
<pre class="prettyprint linenums">SHELL_STATUS_STOP = 0<br />
SHELL_STATUS_RUN = 1
</pre>
<p>现在，我们的内置 cd 已经准备好了。让我们修改 shell.py 来处理这些内置函数。</p>
<pre class="prettyprint linenums">...<br />
### 导入常量<br />
from yosh.constants import *

### 使用哈希映射来存储内建的函数名及其引用<br />
built_in_cmds = {}

def tokenize(string):<br />
    return shlex.split(string)

def execute(cmd_tokens):<br />
    ### 从元组中分拆命令名称与参数<br />
    cmd_name = cmd_tokens[0]<br />
    cmd_args = cmd_tokens[1:]

    ### 如果该命令是一个内建命令，使用参数调用该函数<br />
    if cmd_name in built_in_cmds:<br />
        return built_in_cmds[cmd_name](cmd_args)

    ...
</pre>
<p>我们使用一个 python 字典变量 built_in_cmds 作为哈希映射（，以存储我们的内置函数。我们在 execute 函数中提取命令的名字和参数。如果该命令在我们的哈希映射中，则调用对应的内置函数。</p>
<p>（提示：built_in_cmds[cmd_name] 返回能直接使用参数调用的函数引用。)</p>
<p>我们差不多准备好使用内置的 cd 函数了。最后一步是将 cd 函数添加到 built_in_cmds 映射中。</p>
<p><img referrerpolicy="no-referrer"src="http://www.linuxprobe.com/wp-content/uploads/2016/08/python-shell.png" /></p>
<p>我们定义了 register_command 函数，以添加一个内置函数到我们内置的命令哈希映射。接着，我们定义 init 函数并且在这里注册内置的 cd 函数。</p>
<p>注意这行 register_command("cd", cd) 。第一个参数为命令的名字。第二个参数为一个函数引用。为了能够让第二个参数 cd 引用到 yosh/builtins/cd.py 中的 cd 函数引用，我们必须将以下这行代码放在 yosh/builtins/__init__.py 文件中。</p>
<pre class="prettyprint linenums">from yosh.builtins.cd import *
</pre>
<p>因此，在 yosh/shell.py 中，当我们从 yosh.builtins 导入 * 时，我们可以得到已经通过 yosh.builtins 导入的 cd 函数引用。</p>
<p>我们已经准备好了代码。让我们尝试在 yosh 同级目录下以模块形式运行我们的 shell，python -m yosh.shell。</p>
<p>现在，cd 命令可以正确修改我们的 shell 目录了，同时非内置命令仍然可以工作。非常好！</p>
<div><strong>exit</strong></div>
<p>最后一块终于来了：优雅地退出。</p>
<p>我们需要一个可以修改 shell 状态为 SHELL_STATUS_STOP 的函数。这样，shell 循环可以自然地结束，shell 将到达终点而退出。</p>
<p>和 cd 一样，如果我们在子进程中分叉并执行 exit 函数，其对父进程是不起作用的。因此，exit 函数需要成为一个 shell 内置函数。</p>
<p>让我们从这开始：在 builtins 目录下创建一个名为 exit.py 的新文件。</p>
<pre class="prettyprint linenums">yosh_project<br />
|-- yosh<br />
   |-- builtins<br />
   |   |-- __init__.py<br />
   |   |-- cd.py<br />
   |   |-- exit.py<br />
   |-- __init__.py<br />
   |-- constants.py<br />
   |-- shell.py
</pre>
<p>exit.py 定义了一个 exit 函数，该函数仅仅返回一个可以退出主循环的状态。</p>
<pre class="prettyprint linenums">from yosh.constants import *

def exit(args):<br />
    return SHELL_STATUS_STOP
</pre>
<p>然后，我们导入位于 yosh/builtins/__init__.py 文件的 exit 函数引用。</p>
<pre class="prettyprint linenums">from yosh.builtins.cd import *<br />
from yosh.builtins.exit import *
</pre>
<p>最后，我们在 shell.py 中的 init() 函数注册 exit 命令。</p>
<pre class="prettyprint linenums">...

### 在此注册所有的内建命令<br />
def init():<br />
    register_command("cd", cd)<br />
    register_command("exit", exit)

...
</pre>
<p>到此为止！</p>
<p>尝试执行 python -m yosh.shell。现在你可以输入 exit 优雅地退出程序了。</p>
<div><strong>最后的想法</strong></div>
<p>我希望你能像我一样享受创建 yosh （<strong>y</strong>our <strong>o</strong>wn <strong>sh</strong>ell）的过程。但我的 yosh 版本仍处于早期阶段。我没有处理一些会使 shell 崩溃的极端状况。还有很多我没有覆盖的内置命令。为了提高性能，一些非内置命令也可以实现为内置命令（避免新进程创建时间）。同时，大量的功能还没有实现（请看 公共特性 和 不同特性）。</p>
<p>现在该是创建你真正自己拥有的 Shell 的时候了。<br />
Happy Coding!</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7v2l1q.html">非正规写法获取不到tr&comma;td</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw167k8.html">将对象转为数组方法：延伸array&lowbar;map函数在PHP类中调用内部方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mg4768.html">Searchable&lpar;搜索功能&rpar;（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96owy4y9.html">调试中除了在URL上加时间戳外，如何避免js、css被返回304状态？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljm7de9.html">SVN无法修改以前提交日志的办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kky1z9.html">C语言探索之旅】 第一部分第四课第三章：变量的世界之显示变量内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m2y1n8.html">PHP控制连接打印机</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jznjz08.html">dotnet webservice处理数据量过大，ajax请求返回500错误解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd35e49.html">JavaSE教程-04Java中循环语句for，while，do&amp;&num;183&semi;&amp;&num;183&semi;&amp;&num;183&semi;while</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jyvgx8.html">GoldenGate 传统抽取进程随 DataGuard 主备快速切换的方案（ADG 模式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojlwypq.html">Python 解LeetCode：Intersection of Two Arrays</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z503j9.html">Qt 的一些浅知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z1eyg9.html">ES6&lpar;数值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkmo7v8.html">How Tomcat Works 读书笔记 八 载入器 上</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4kzpe9.html">The type org&period;springframework&period;context&period;ConfigurableApplicationContext cannot be resolved&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jl5r0q.html">jmeter关联Websocket包支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw6dov9.html">MVC返回文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn4yedq.html">setcursor 与 showcursor</a>
		</li>
						<li><a href="https://www.batexi.com/a/95373lm8.html">windowbuilder</a>
		</li>
						<li><a href="https://www.batexi.com/a/953kpzm8.html">360全景技术支持中心&lpar;KRPanoGUI三维全景制作软件&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/jqdngm09.html">php模式设计之 观察者模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93egrnq.html">分布式人工智能标记语言（DAIML）示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdnr609.html">微信小程序内测申请</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q76jje8.html">css兼容性的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p0ejdq.html">初探JAVA中I&sol;O流&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ozpvx9.html">new-nav-css</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdn1m79.html">（转）在WAMPSERVER下增加多版本的PHP（PHP5&period;3，PHP5&period;4，PHP5&period;5）支持</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4rvee8.html">进化策略-python实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93e4k0q.html">【bzoj2115】 Xor</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kye739.html">input使用javascript限制输入带小数的数字</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
